8709
Comment: Trim down example and leave only option handling
|
9029
Fix --file option's shift command
|
Deletions are marked like this. | Additions are marked like this. |
Line 12: | Line 12: |
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, it may suffice. Here's an example that will handle a combination of short (`-v`, `-h`) and long (`--verbose`, `--help`) options; and also style `--verbose=LEVEL`. |
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, it may suffice. Here's an example that will handle a combination of short and long options. Notice how the handling of various styles of "--verbose", "--verbose LEVEL" and "--verbose=LEVEL" are handled. {{{#!highlight bash #!/bin/sh |
Line 18: | Line 23: |
help="" # Reset all option variables that might be set later | file="" # Reset all variables that might be set |
Line 25: | Line 30: |
-f | --file) file="$1" # You might want to check if you really got FILE shift 2 ;; |
|
Line 26: | Line 35: |
help="help" shift # Remove from argument list # Now, e.g. call Help() function |
# Call your Help() function here. exit 0 # This not an error, User asked help. Don't do "exit 1" |
Line 33: | Line 41: |
verbose_level=${1#*=} # Delete everyting up till "=" | verbose_level=${1#*=} # Delete everything up till "=" |
Line 37: | Line 45: |
# Support "--verbose" |
|
Line 41: | Line 51: |
# Support "--verbose LEVEL" by reading next argument. | # Support additional "--verbose LEVEL" by reading next argument. |
Line 54: | Line 64: |
Warn "WARN: Unknown option: $1" | echo "WARN: Unknown option: $1" >&2 |
Line 63: | Line 73: |
# Suppose, some options are required. Check that we got them [ "$verbose" ] || Die "ERROR: option --verbose not given. See --help" # <Rest of your code here> |
# Suppose, some options are required. Check that we got them. # Make --verbose a required option: if [ ! "$verbose" ]; then echo "ERROR: option --verbose not given. See --help" >&2 return 1 fi # <Rest of the program here> |
Line 76: | Line 90: |
parse separate options concatenaed together. Like like `-xvf` which would understoos as `-x -v -f`. This could be possible with lot of effort, but in practise it wouldn't be worth it. |
parse separate options concatenated together. Like like `-xvf` which would understood as `-x -v -f`. This could be possible with lot of effort, but in practice it wouldn't be worth it. |
Line 109: | Line 123: |
v) verbose=1 ;; f) output_file=$OPTARG |
v) verbose=1 ;; f) output_file=$OPTARG |
Line 131: | Line 145: |
[[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. |
[[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. |
Line 149: | Line 163: |
[[http://pubs.opengroup.org/onlinepubs/9699919799/utilities/getopts.html|POSIX standard]] says there must be a space between them; bash and dash |
[[http://pubs.opengroup.org/onlinepubs/9699919799/utilities/getopts.html|POSIX standard]] says there must be a space between them; bash and dash |
Line 182: | Line 196: |
# End of file |
|
Line 237: | Line 253: |
[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code: | [[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code: |
How can I handle command-line arguments (options) to my script easily?
Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.
Contents
Manual loop
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, it may suffice. Here's an example that will handle a combination of short and long options. Notice how the handling of various styles of "--verbose", "--verbose LEVEL" and "--verbose=LEVEL" are handled.
1 #!/bin/sh
2
3 Main ()
4 {
5 file="" # Reset all variables that might be set
6 verbose=""
7 verbose_level=""
8
9 while :
10 do
11 case "$1" in
12 -f | --file)
13 file="$1" # You might want to check if you really got FILE
14 shift 2
15 ;;
16 -h | --help)
17 # Call your Help() function here.
18 exit 0 # This not an error, User asked help. Don't do "exit 1"
19 ;;
20 --verbose=*)
21 # If you want to support --option=VALUE style
22 verbose="verbose"
23 verbose_level=${1#*=} # Delete everything up till "="
24 shift
25 ;;
26 -v | --verbose)
27 # Support "--verbose"
28
29 verbose="verbose"
30 verbose_level=1
31 shift
32
33 # Support additional "--verbose LEVEL" by reading next argument.
34
35 case "$1" in
36 [0-9]) verbose_level=$1
37 shift
38 ;;
39 esac
40 ;;
41 --) # End of all options
42 shift
43 break
44 ;;
45 -*)
46 echo "WARN: Unknown option: $1" >&2
47 shift
48 ;;
49 *) # no more options. Stop while loop
50 break
51 ;;
52 esac
53 done
54
55 # Suppose, some options are required. Check that we got them.
56 # Make --verbose a required option:
57
58 if [ ! "$verbose" ]; then
59 echo "ERROR: option --verbose not given. See --help" >&2
60 return 1
61 fi
62
63 # <Rest of the program here>
64 }
65
66 Main "$@"
67
68 # End of file
What is not possible to do with pure shell approach, is to try to parse separate options concatenated together. Like like -xvf which would understood as -x -v -f. This could be possible with lot of effort, but in practice it wouldn't be worth it.
You may be interested in knowing that some Bash programmers like to write this at the beginning of their scripts to guard against unused variables:
set -u # or, set -o nounset
getopts
Never use getopt(1). getopt cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed.
The POSIX shell (and others) offer getopts which is safe to use instead. Here is a simplistic getopts example:
1 #!/bin/sh
2
3 # A POSIX variable
4 OPTIND=1 # Reset in case getopts has been used previously in the shell.
5
6 while getopts "h?vf:" opt; do
7 case "$opt" in
8 h|\?)
9 show_help
10 exit 0
11 ;;
12 v) verbose=1
13 ;;
14 f) output_file=$OPTARG
15 ;;
16 esac
17 done
18
19 shift $((OPTIND-1))
20
21 [ "$1" = "--" ] && shift
22
23 echo "verbose=$verbose, output_file='$output_file', Leftovers: $@"
24
25 # End of file
The disadvantage of getopts is that it can only handle short options (-h) without trickery. It handles -vf filename in the expected Unix way, automatically. getopts is a good candidate because it is portable and e.g. also works in dash.
There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts, which might be informative.
There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.
Here is an example which parses long options with getopts. The basic idea is quite simple: just put "-:" into the optstring. This trick requires a shell which permits the option-argument (i.e. the filename in "-f filename") to be concatenated to the option (as in "-ffilename"). The POSIX standard says there must be a space between them; bash and dash permit the "-ffilename" variant, but one should not rely on this leniency if attempting to write a portable script.
1 #!/bin/bash
2 # Uses bash extensions. Not portable as written.
3
4 optspec=":h-:"
5
6 while getopts "$optspec" optchar
7 do
8 case "${optchar}" in
9 -)
10 case "${OPTARG}" in
11 loglevel)
12 eval val="\$${OPTIND}"; OPTIND=$(( $OPTIND + 1 ))
13 echo "Parsing option: '--${OPTARG}', value: '${val}'" >&2
14 ;;
15 loglevel=*)
16 val=${OPTARG#*=}
17 opt=${OPTARG%=$val}
18 echo "Parsing option: '--${opt}', value: '${val}'" >&2
19 ;;
20 esac
21 ;;
22 h)
23 echo "usage: $0 [--loglevel[=]<value>]" >&2
24 exit 2
25 ;;
26 esac
27 done
28
29 # End of file
Silly repeated brute-force scanning
Another approach is to check options with if statements "on demand". A function like this one may be useful:
1 #!/bin/bash
2
3 HaveOpt ()
4 {
5 local needle=$1
6 shift
7
8 while [[ $1 == -* ]]
9 do
10 # By convention, "--" means end of options.
11 case "$1" in
12 --) return 1 ;;
13 $needle) return 0 ;;
14 esac
15
16 shift
17 done
18
19 return 1
20 }
21
22 HaveOpt --quick "$@" && echo "Option quick is set"
23
24 # End of file
and it will work if script is run as:
- YES: ./script --quick
- YES: ./script -other --quick
but will stop on first argument with no "-" in front (or on --):
- NO: ./script -bar foo --quick
- NO: ./script -bar -- --quick
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables.
It also spreads the options throughout the program. The literal option --quick may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance.
Complex nonstandard add-on utilities
bhepple suggests the use of process-getopt (GPL licensed) and offers this example code:
PROG=$(basename $0) VERSION='1.2' USAGE="A tiny example using process-getopt(1)" # call process-getopt functions to define some options: source process-getopt SLOT="" SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option add_opt SLOT "boolean option" s "" slot TOKEN="" TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option add_opt TOKEN "this option takes a value" t n token number add_std_opts # define the standard options --help etc: TEMP=$(call_getopt "$@") || exit 1 eval set -- "$TEMP" # just as with getopt(1) # remove the options from the command line process_opts "$@" || shift "$?" echo "SLOT=$SLOT" echo "TOKEN=$TOKEN" echo "args=$@"
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.
Actually, what the author forgot to say was that it's actually using getopts semantics, rather than getopt. I ran this test:
~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'" ~/process-getopt-1.6$ call_getopt "$@" -- 'rm -rf /' 'foo;bar' ''\'''
It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the eval not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat
It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for getopt --test) it only processes short options. It does not use the bash builtin getopts(1) command. -bhepple